#include <windows.h>
#include <iostream>
#include "dll.h"

using namespace std;

typedef DllObjectParent * (__stdcall *PFNCreate)();

int main()
{
	cout << "Load The DLL" << endl;
	HMODULE hmod = LoadLibrary("mydll.dll");
	if (!hmod) return 1;

	cout << "Find the proc adrress of CreateDllObject" << endl;
	PFNCreate pfnCreate = (PFNCreate)GetProcAddress(hmod, TEXT("CreateDllObject"));
	if (!pfnCreate) return 2;

	cout << "Use CreateDllObject to create an object" << endl;
	DllObjectParent * obj = (pfnCreate)();

	// do something with obj here

	cout << "Attempt to clean up the object with virtual \"release()\"" << endl;
	obj->release();

	cout << "Free the dll" << endl;
	FreeLibrary(hmod);

	cout << "End of program";
	return 0;
}

