#include <iostream>
#define DLL_EXPORT
#include "dll.h"

using namespace std;

class DllObject : public DllObjectParent
{
public:
	~DllObject()
	{
		cout << "DllObject Deconstructor" << endl;
	}

	virtual void release()
	{
		delete this;
		cout << "DllObject Released" << endl;
	}
};

extern "C" DllObjectParent * MYAPI __stdcall CreateDllObject()
{
	return new DllObject;
}

